﻿##############################################
####### Websitepanel Public folder fix #######
#### Created by Key4ce - IT Professionals ####
############# https://key4ce.com #############
##############################################

# Set These Prams
Clear-Host
# This is the OU in the format of OU=Mail2012,OU=Customers,DC=mail4ce,DC=com
$MailOU = "OU=Mail2012,OU=Customers,DC=mail4ce,DC=com"
$MailOU2= "mail4ce.com/Customers/Mail2012"
$RootDomain = "mail4ce.com"

# Get SubOU
$SubOUs = Get-ADOrganizationalUnit -SearchBase $MailOU -Filter *

# Foreach OU
Foreach ($SubOU in $SubOUs[1..$($subous.count)]){
        Clear-Variable SubOUPriSMTP -ErrorAction SilentlyContinue
        $SubOUSMTP = ""
        $SubOUname = $SubOU.Name
        $SubOUDistName = $SubOU.DistinguishedName
        #$SubOUPFName = Get-ADUser -Filter {distinguishedName -eq "CN=$SubOUName Public Folder Mailbox,$SubOUDistName"}
        Write-Host "OU: $SubOUname"
        $SubOUPfName = "$SubOUName Public Folder Mailbox"
        [array]$user = Get-ADUser -Filter 'Name -eq $SubOUPfName'
        # Find Domain of OU users
        $OUMailboxs = Get-ADuser -Filter * -SearchBase "$SubOUDistName"
        ForEach ($OUMailbox in $OUMailboxs) {
            $upn = $OUMailbox.UserPrincipalName
            $ok = $upn -match "@(?<Domain>.*)$"
            $SubOUPriDomain = $matches["Domain"]
            If ($SubOUPriDomain) { break }
        }

        $SubOUPriSMTP = "$SubOUname`1@$SubOUPriDomain"
        Write-Host "`t Domain: $SubOUPriDomain"

        # Checking if PF is created
        if ($user.Count -eq 0) {
            Write-Host "`t- user not found."
            # Creating PF Mailbox
            New-Mailbox -PublicFolder -Name "$SubOUPfName" -OrganizationalUnit "$MailOU2/$SubOUName" -AddressBookPolicy "$SubOUName Address Policy"
            Start-Sleep -s 10
            New-PublicFolder -Name "$SubOUName" -Path "\" -mailbox "$SubOUPfName"
            Remove-PublicFolderClientPermission -Identity "\$SubOUName" -User Default -Confirm:$False
            Add-PublicFolderClientPermission -Identity "\$SubOUName" -User $SubOUName@$RootDomain -AccessRights Reviewer
        } else {
            Write-Host "`t- Public Folder Mailbox user found."
            # If the user is present then it checks the OU to make sure it is in the correct place
            if ($user[0].DistinguishedName -ne "CN=$SubOUPfName,$SubOUDistName") {
                Write-Host "`t`t- DN does not match. - No Changes to PF permissions made"
            } else {
                # Write-Host "`t`t- DN does match."
                Add-PublicFolderClientPermission -Identity "\$SubOUName" -User $SubOUName@$RootDomain -AccessRights Reviewer
                Remove-PublicFolderClientPermission -Identity "\$SubOUName" -User Default -Confirm:$False
            }
        }
        #Now we have setup the Public Mailbox and made sure they are both set it up. We will now sysle through the users and set them up
        Get-Mailbox -OrganizationalUnit "$SubOUDistName" | ForEach-Object { Set-Mailbox $_.alias -DefaultPublicFolderMailbox "$MailOU2/$SubOUname/$SubOUPfName" }

}
